'Script replicates all .LOG files from source to target. 
'It creates a time stamped folder to copy the files to
'It also deletes any of it's own log file after coping them
'when they have become over a day old
' 02/24/2003 added file names EXPORT and IMPORT to backup code

public DTStamp, tWork1, tWork2, thisLogFile, targetDir, logFileDir
public fromDir, toDir, WshShell, logStamp, hldTimer1, hldTimer2
public thisLogPrefix, arcFolderPrefix, thisLogFileName, BkupFlag

hldTimer1 = Timer()
hldTimer1 = hldTimer1 + 1.1

' Set the folders to use NOTE Do not put a ending \ on directory
'logFileDir is where the log files reside to archive
'targetDir is where you want the folders to be created to hold the log files
logFileDir = "C:\temp2"
targetDir = "C:\temp2\Archive_Logs"
thisLogPrefix = "LA-"
arcFolderPrefix = "Logs"

Set WshShell = Wscript.CreateObject("Wscript.Shell")

start = Now()
replaceSize = 0
copySize = 0
deleteSize = 0
noChangeSize = 0

' Set Date Time Variable DTStamp
' get current year to 2 places
tWork1 = right(cstr(year(date())),2)
DTStamp = tWork1
' Get month to 2 places
tWork1 = cstr(month(date()))
tWork2 = len(tWork1)
if tWork2 = 1 then tWork1 = "0" & tWork1
DTStamp = DTStamp & tWork1
' Get Day to 2 places
tWork1 = cstr(day(date()))
tWork2 = len(tWork1)
if tWork2 = 1 then tWork1 = "0" & tWork1
DTStamp = DTStamp & tWork1
' Get Hour to 2 places
tWork1 = cstr(hour(now()))
tWork2 = len(tWork1)
if tWork2 = 1 then tWork1 = "0" & tWork1
DTStamp = DTStamp & tWork1
' Get Minutes to 2 places
tWork1 = cstr(minute(now()))
tWork2 = len(tWork1)
if tWork2 = 1 then tWork1 = "0" & tWork1
DTStamp = DTStamp & tWork1

' Set the log file filename for this run of this script
' Get Seconds to 2 places
tWork1 = cstr(second(now()))
tWork2 = len(tWork1)
if tWork2 = 1 then tWork1 = "0" & tWork1
logStamp = DTStamp & tWork1
thisLogFileName = thisLogPrefix & logStamp & ".log"
thisLogFile = logFileDir & "\" & thisLogFileName

' Set the folder to use
fromDir = logFileDir
toDir = targetDir & "\" & arcFolderPrefix & "_" & DTStamp

Set fso = CreateObject("Scripting.FileSystemObject")

Set logFile = fso.OpenTextFile(thisLogFile, 8, True)
logFile.WriteLine("")
logFile.WriteLine("Start ...................... : " & start)
logFile.WriteLine("Source ..................... : " & fromDir)
logFile.WriteLine("Target ..................... : " & toDir)

' Check source folder exists
If fso.FolderExists(fromDir) Then
  ' OK we have it
Else
  logFile.WriteLine("Error *** .................. : SOURCE FOLDER CAN NOT BE REACHED")
  WScript.quit 4
End If

' Check destination folder does NOT exist (we want to create it)
If fso.FolderExists(toDir) Then
  logFile.WriteLine("Error *** .................. : TARGET FOLDER ALREADY EXIST")
  WScript.quit 5
End If

' Lets create the new folder
fso.CreateFolder(toDir)
'Lets verify it exsits now
If fso.FolderExists(toDir) Then
  ' Good, lets continue
Else
  logFile.WriteLine("Error *** .................. : CREATE TARGET FOLDER FAILED")
  WScript.quit 6
End If

Call ReplicateDirectory(fromDir, toDir)

Sub ReplicateDirectory(source, target)
Set targetDir = fso.GetFolder(target)
Set sourceDir = fso.GetFolder(source)
Set sourceDirFileList = sourceDir.Files
For Each sourceFile in sourceDirFileList
  BkupFlag = "N"
  If UCase(Right(sourceFile.Name,4)) = ".LOG" AND thisLogFileName <> sourceFile.Name Then
    BkupFlag = "Y"
  end if
  If UCase(sourceFile.Name) = "IMPORT" OR UCase(sourceFile.Name) = "EXPORT" Then
    BkupFlag = "Y"
  end if
  if BkupFlag = "Y" then
    copySize = copySize + sourceFile.Size
    sourceFile.Copy targetDir.Path & "\" & sourceFile.Name
    logFile.WriteLine("Copied to target ........... : " & sourceFile.Name)
    If left(sourceFile.Name,len(thisLogPrefix)) = thisLogPrefix AND Mid(sourceFile.Name,len(thisLogPrefix)+1,6) <> Left(DTStamp,6) then
      ' Remove old log files from this program
      logFile.WriteLine("Old Log Deleted ............ : " & sourceFile.Name)
      sourceFile.Delete
    End if
  End If
Next
End Sub

' Used to make sure we are at least 1 second different between start and end
' This is in case another one of these are scheduled right after and it would
' fail because of the same log fle name
hldTimer2 = Timer()
Do While hldTimer1 > hldTimer2
  hldTimer2 = Timer()
Loop

finish = Now()

logFile.WriteLine("Copied to target ........... : " & Round(copySize / 1024 /1024, 1) & " MB")
logFile.WriteLine("Execution Time ............. : " & DateDiff("n", start, finish) & " MIN")
logFile.WriteLine("Finish ..................... : " & finish)
logFile.Close() 